//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

::timers <- [];

function InitTimer()
{
    local timerHolder = SpawnEntityFromTable("prop_dynamic", { model = "models/empty.mdl" });
    timerHolder.ValidateScriptScope();
    timerHolder.GetScriptScope().LizardLibThink <- function()
    {
        main_script.LizardLibThink();
        return -1;
    }
    AddThinkToEnt(timerHolder, "LizardLibThink");
}
InitTimer();

function LizardLibThink()
{
    local time = Time();
    foreach (entry in timers)
    {
        try
        {
            local rng = RandomInt(0, 999);
            if (time - entry[3] >= entry[4])
            {
                entry[4] += entry[3];
                entry[1].acall([entry[2]]);
            }
        }
        catch (e) { throw e; }
    }
    return -1;
}

::AddTimer <- function(interval, order, timerFunc, scope = this)
{
    if (interval < 0)
        interval = 0;
    local timerEntry = [order, timerFunc, scope, interval, Time()];

    local size = timers.len();
    local i = 0;
    for (; i < size; i++)
    if (timers[i][0] > order)
        break;
    timers.insert(i, timerEntry);

    return timerEntry;
}

::OnTick <- AddTimer;