IncludeScript("gungame/gamemode/scoreboard.nut")
IncludeScript("gungame/gamemode/assist_manager.nut")

Convars.SetValue("tf_weapon_criticals", 1);
Convars.SetValue("mp_friendlyfire", 1);
Convars.SetValue("mp_autoteambalance", 0);
Convars.SetValue("mp_teams_unbalance_limit", 0);
Convars.SetValue("tf_classlimit", 0);
Convars.SetValue("cl_use_tournament_specgui", 0);
Convars.SetValue("mp_forcecamera", 0);
Convars.SetValue("sv_alltalk", 1);
Convars.SetValue("tf_dropped_weapon_lifetime", 0);
Convars.SetValue("mp_scrambleteams_auto", 0);
Convars.SetValue("mp_disable_respawn_times", 1);
Convars.SetValue("sv_vote_issue_autobalance_allowed", "0");
Convars.SetValue("tf_spawn_glows_duration", "0");
Convars.SetValue("tf_avoidteammates", "0");
Convars.SetValue("sv_vote_issue_scramble_teams_allowed", "0");
Convars.SetValue("tf_use_fixed_weaponspreads", "1");

team_round_timer = SpawnEntityFromTable("team_round_timer", {
    targetname = "team_round_timer",
    auto_countdown = 1,
    max_length = 0,
    reset_time = 1,
    show_in_hud = 1,
    show_time_remaining = 1,
    start_paused = 0,
    timer_length = 345,
    StartDisabled = 0,
    "OnFinished": "!self,RunScriptCode,EndRoundGlobal(),0,-1" //todo fix
});

game_text <- SpawnEntityFromTable("game_text",
    {
        targetname = "game_text",
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 0,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        spawnflags = 1,
        x = -1,
        y = -1,
        message = "",
    });

::ended <- false;

::EndRoundGlobal <- function()
{
    EntFireByHandle(main_script, "RunScriptcode", "EndRound()", -1, null, null)
    main_script.EndRound();
}

function EndRound(winner = null)
{
    EmitSoundEx({
        sound_name = "player/taunt_bell.wav",
        volume = 1,
        channel = 0,
        sound_level = 150,
        filter_type = RECIPIENT_FILTER_GLOBAL
    });
    RunWithDelay(this, 15, function() {
        Convars.SetValue("mp_restartgame_immediate", "1");
    })
    if (GetAllClients().len() == 0)
        return;
    ended = true;
    local winnerKills = winner ? kills[winner.entindex()] : -1;
    local second = GetAllClients()[0];
    local secondKills = -1;
    foreach (player in GetAllClients())
    {
        local myKills = kills[player.entindex()];
        if (myKills > winnerKills)
        {
            winner = player;
            winnerKills = myKills;
        }
    }
    foreach (player in GetAllClients())
    {
        if (player == winner)
            continue;
        local myKills = kills[player.entindex()];
        if (myKills > secondKills)
        {
            second = player;
            secondKills = myKills;
        }
    }
    foreach (player in GetAlivePlayers())
    {
        if (player != winner)
            player.AddCustomAttribute("no_attack", 1, 15);
        else
            player.AddCond(TF_COND_CRITBOOSTED)
    }

    AddTimer(0.1, 0, function ()
    {
        DoEntFire("game_text", "AddOutput", "message "+GetPropString(winner, "m_szNetname")+" won!\n"+GetPropString(second, "m_szNetname")+" is 2nd", 0, winner, winner);
        DoEntFire("game_text", "Display", "", 0, null, null);
    });
}