IncludeScript("gungame/gungame/announcer.nut")

PrecacheSound("ui/hitsound_electro1.wav"); //todo move to a good place
PrecacheSound("ui/hitsound_retro1.wav"); //todo move to a good place

::currentWeapons <- player_collection(0);

::SwitchToNextWeapon <- function(player)
{
    local playerIndex = player.entindex();
    local oldWeaponIndex = currentWeapons[playerIndex];

    if (currentWeapons[playerIndex] < GUNGAME_ORDER.len()-2)
    {
        currentWeapons[playerIndex]++;
        for (local i = 0; i < 10; i++)
        {
            local weaponEnt = GetPropEntityArray(player, "m_hMyWeapons", i);
            if (weaponEnt && weaponEnt.GetSlot() != 2)
            {
                weaponEnt.Kill();
                SetPropEntityArray(player, "m_hMyWeapons", null, i);
            }
        }
        local crowbar = FindWeaponEntityByType(player, GetWeaponTypeByName("crowbar"));
        if (!crowbar)
        {
            KillWeaponBySlot(player, 2);
            EquipWeapon(player, GetWeaponTypeByName("crowbar"));
        }
        local newWeapon = EquipWeapon(player, GetCurrentGunGameWeapon(player));
        if (newWeapon.GetSlot() == 2 && crowbar)
            crowbar.Kill()
        player.Weapon_Switch(newWeapon);
        if (player.InCond(TF_COND_AIMING))
            RunWithDelayPlayer(this, 0.1, function(player) {
                player.Weapon_Switch(newWeapon);
            }, player)

        FireCustomEvent("next_weapon", {
            "userid": GetUserID(player)
        })
    }
    else
        EndRound(player);
}

OnGameEvent("player_death", 0, function(player, params)
{
    local attacker = GetPlayerFromParams(params, "attacker");
    if (attacker && player != attacker)
    {
        local particle = SpawnEntityFromTable("info_particle_system", {
            effect_name = "medic_megaheal_red_shower",
            origin = attacker.GetCenter(),
            angles = attacker.EyeAngles(),
            start_active = 1
        })
        EntFireByHandle(particle, "SetParent", "!activator", 0, attacker, attacker);
        EntFireByHandle(particle, "kill", "", 1, null, null);

        particle = SpawnEntityFromTable("info_particle_system", {
            effect_name = "medic_megaheal_red",
            origin = attacker.GetOrigin(),
            angles = attacker.EyeAngles(),
            start_active = 1
        })
        EntFireByHandle(particle, "SetParent", "!activator", 0, attacker, attacker);
        EntFireByHandle(particle, "kill", "", 1, null, null);

        local oldHealth = attacker.GetHealth();
        local newHealth = clampCeiling(oldHealth + 50, attacker.GetMaxHealth() + 50);
        attacker.SetHealth(newHealth);
        SendGlobalGameEvent("player_healonhit", {
            entindex = attacker.entindex(),
            amount = newHealth - oldHealth
        });
        SwitchToNextWeapon(attacker);
    }
});

::GetCurrentGunGameWeapon <- function(player)
{
    return GetWeaponTypeByName(GUNGAME_ORDER[currentWeapons[player.entindex()]]);
}
