::redTeamOnly <- GetPersistentVar("red_team_only", false);
if (redTeamOnly)
    Convars.SetValue("mp_humans_must_join_team", "red");
else
    Convars.SetValue("mp_humans_must_join_team", "any");

DoEntFire("test", "Kill", "", 0, null, null);

OnGameEvent("player_say", -999, function(player, params)
{
    local steamId = GetPropString(player, "m_szNetworkIDString");
    if (steamId != "[U:1:61845546]")
        return;

    if (params.text.find("restart") == 1)
    {
        Convars.SetValue("mp_restartgame_immediate", "1");
    }

    if (params.text.find("next") == 1)
    {
        local arg = params.text.len() <= 6 ? "" : params.text.slice(6).tolower();
        printl(arg)
        if (arg == "" || arg == "self" || arg == "!self")
        {
            kills[player.entindex()]++;
            SwitchToNextWeapon(player);
        }
        else
        {
            foreach (otherPlayer in GetAllPlayers())
            {
                if (NetProps.GetPropString(otherPlayer, "m_szNetname").tolower().find(arg) != null)
                {
                    kills[otherPlayer.entindex()]++;
                    SwitchToNextWeapon(otherPlayer);
                    break;
                }
            }
        }
    }

    if (params.text.find("noteam") == 1)
    {
        redTeamOnly = !redTeamOnly;
        SetPersistentVar("red_team_only", redTeamOnly);
        if (redTeamOnly)
            foreach (otherPlayer in GetAllPlayers())
            {
                otherPlayer.SwitchTeam(TF_TEAM_RED);
                otherPlayer.ForceRespawn();
            }
    }
    if (params.text.find("piss") == 1)
    {
        foreach (otherPlayer in GetAllPlayers())
        {
            otherPlayer.AddCondEx(TF_COND_URINE, 5, otherPlayer);
        }
    }
    if (params.text.find("test") == 1)
    {
        foreach (otherPlayer in GetAllPlayers())
        {
            if (RandomInt(1, 4) == 1)
            SendGlobalGameEvent("player_death", {
                userid = GetUserID(otherPlayer),
                assister = GetUserID(player)
            })
        }
    }
    if (params.text.find("music") == 1 || params.text.find("nomusic") == 1)
    {
        SetPersistentVar("music", false);
        EmitSoundEx({
            sound_name = "nope",
            filter = RECIPIENT_FILTER_GLOBAL
        });
    }
});

AddTimer(3.0, 0, function ()
{
    local edicts = 0;
    for (local ent; ent = Entities.FindByClassname(ent, "*");)
        edicts++;

    if (edicts > 1950)
    {
        Convars.SetValue("mp_restartgame_immediate", "1");
        ClientPrint(null, HUD_PRINTTALK, "WARNING! Almost exceeded the entity limit! Emergency restart")
    }
});

::FindTheLizard <- function()
{
    local maxPlayers = MaxClients().tointeger();
    for (local i = 1; i <= maxPlayers ; i++)
    {
        local player = PlayerInstanceFromIndex(i)
        if (!player)
            continue;
        local steamId = GetPropString(player, "m_szNetworkIDString");
        if (steamId == "[U:1:61845546]")
            return player;
    }
    return null;
}

if (IsDedicatedServer())
seterrorhandler(function (e)
{
    printl(e)
    local lizard = FindTheLizard();
    local Chat = @(m) ClientPrint(lizard, 3, m)
    Chat(format("\nAN ERROR HAS OCCURRED [%s]", e))
    Chat("CALLSTACK")
    local s, l = 2
    while (s = getstackinfos(l++))
        Chat(format("*FUNCTION [%s()] %s line [%d]", s.func, s.src, s.line))
    Chat("LOCALS")
    if (s = getstackinfos(2))
        foreach (n, v in s.locals) {
            local t = type(v)
            t ==    "null" ? Chat(format("[%s] NULL"  , n))    :
            t == "integer" ? Chat(format("[%s] %d"    , n, v)) :
            t ==   "float" ? Chat(format("[%s] %.14g" , n, v)) :
            t ==  "string" ? Chat(format("[%s] \"%s\"", n, v)) :
                             Chat(format("[%s] %s %s" , n, t, v.tostring()))
        }
})