movespeeds <- player_collection(0);
spareTimeStamp <- player_collection(0);
hasJumped <- player_collection(0);

PrecacheSound("vo/mercenary_jump01.mp3")
PrecacheSound("vo/mercenary_jump02.mp3")
PrecacheSound("vo/mercenary_jump03.mp3")

vo_jump_sounds <- ["vo/mercenary_jump01.mp3", "vo/mercenary_jump02.mp3", "vo/mercenary_jump03.mp3"]

AddTimer(-1, 0, function()
{
    foreach(player in GetAlivePlayers())
    {
        local entIndex = player.entindex();
        if (player.GetFlags() & FL_ONGROUND)
            hasJumped[entIndex] = false;
        else if (!hasJumped[entIndex] && (GetPropInt(player, "m_nButtons") & IN_JUMP))
        {
            hasJumped[entIndex] = true;
            EmitSoundEx({
                sound_name = vo_jump_sounds[RandomInt(0, vo_jump_sounds.len() - 1)],
                entity = player,
                volume = 0.6,
                sound_level = 90,
            });
        }

        local newSpeed = player.GetAbsVelocity().Length2D();
        if (!(player.GetFlags() & FL_ONGROUND))
        {
            if (newSpeed > 310)
            {
                local delta = (newSpeed - 310) / 520;
                spareTimeStamp[entIndex] = Time();
                if (movespeeds[entIndex] < 70)
                    movespeeds[entIndex] += 0.2 + delta;
            }
        }
        else if (newSpeed < 250)
        {
            movespeeds[entIndex] = clampFloor(0, movespeeds[entIndex] - 2);
        }
        else if (Time() - spareTimeStamp[entIndex] > 0.2)
        {
            movespeeds[entIndex] = clampFloor(0, movespeeds[entIndex] - 1.2);
        }
        if (movespeeds[entIndex] > 50 && player.GetAbsVelocity().Length2D() > 480)
            player.AddCondEx(TF_COND_SPEED_BOOST, 0.3, player);
        if (RandomInt(1, 10) == 1)
            player.AddCustomAttribute("move speed bonus",
                1.04 / MERC_MOVESPEED_MULTIPLIER[player.GetPlayerClass()] + movespeeds[entIndex] / 70.0,
                -1);
    }
});