IncludeScript("gungame/weapons/weapon_fixes.nut");
IncludeScript("gungame/weapons/weapon_list.nut");
IncludeScript("gungame/weapons/weapon_models.nut");

PrecacheModel("models/weapons/c_models/c_merc_arms.mdl")

lastWeaponEnts <- player_collection(null);

AddTimer(-1, -10, function ()
{
    foreach (player in GetAlivePlayers())
    {
        local playerIndex = player.entindex();
        local lastWeaponEnt = lastWeaponEnts[playerIndex];
        local weaponEnt = player.GetActiveWeapon();

        if (weaponEnt == lastWeaponEnt)
            continue;
        lastWeaponEnts[playerIndex] = weaponEnt;
        if (!weaponEnt)
            continue;

        local weaponScript = weaponEnt.GetScriptScope();
        if ("OnSwitch" in weaponScript)
            weaponScript.OnSwitch(player, weaponScript.weaponTT);
        if ("weaponTT" in weaponScript)
        {
            RefreshCharacter(player, weaponScript.weaponTT, true);
        }
    }
});

::CreateWeapon <- function(player, weaponTT)
{
    local weaponEnt = Entities.CreateByClassname(weaponTT.baseclass);
    SetPropInt(weaponEnt, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", weaponTT.baseid);
    SetPropBool(weaponEnt, "m_AttributeManager.m_Item.m_bInitialized", true);
    SetPropBool(weaponEnt, "m_bValidatedAttachedEntity", true);
	SetPropBool(weaponEnt, "m_bClientSideAnimation", true);
    weaponEnt.SetTeam(player.GetTeam());
    weaponEnt.SetOwner(player);
	SetPropEntity(weaponEnt, "m_hOwnerEntity", player);
    SetPropBool(weaponEnt, "m_bForcePurgeFixedupStrings", true);
    Entities.DispatchSpawn(weaponEnt);
    return weaponEnt;
}

::EquipWeapon <- function(player, weaponTT)
{
    local weaponEnt = CreateWeapon(player, weaponTT);
    player.Weapon_Equip(weaponEnt);
    if ("OnEquip" in weaponTT)
        weaponTT.OnEquip(player, weaponTT, weaponEnt);

    if ("animmodel" in weaponTT)
    {
        weaponEnt.SetModelSimple(weaponTT.animmodel);
        weaponEnt.SetCustomViewModelModelIndex(GetModelIndex(weaponTT.animmodel));
        SetPropInt(weaponEnt, "m_iViewModelIndex", GetModelIndex(weaponTT.animmodel));
    }

    weaponEnt.ValidateScriptScope();
    weaponEnt.GetScriptScope().weaponTT <- weaponTT;
    if ("OnSwitch" in weaponTT)
        weaponEnt.GetScriptScope().OnSwitch <- weaponTT.OnSwitch;
    return weaponEnt;
}