::handsModels <- player_collection(null);
::viewModels <- player_collection(null);
::worldModels <- player_collection(null);

::RefreshModels <- function(player)
{
    local weaponEnt = player.GetActiveWeapon();
    local weaponTT = GetWeaponTypeFromEntity(weaponEnt);
    if (!weaponTT)
        return;

    local entsToKill = [];
    for(local viewmodel = null; viewmodel = Entities.FindByClassname(viewmodel, "tf_wearable*");)
        if (viewmodel.GetOwner() == player)
            entsToKill.push(viewmodel);
    foreach (ent in entsToKill)
        ent.Kill();

    local viewModel = GetPropEntity(player, "m_hViewModel");
    viewModel.DisableDraw();

    TrySpawnViewModel(player).SetModelSimple("models/weapons/c_models/c_merc_arms.mdl");

    if ("animmodel" in weaponTT)
    {
        weaponEnt.SetModelSimple(weaponTT.animmodel);
        weaponEnt.SetCustomViewModelModelIndex(GetModelIndex(weaponTT.animmodel));
        SetPropInt(weaponEnt, "m_iViewModelIndex", GetModelIndex(weaponTT.animmodel));

        player.Weapon_Switch(weaponEnt);
        viewModel.DisableDraw();
    }
    if ("weaponmodel" in weaponTT)
    {
        TrySpawnViewModel(player).SetModelSimple(weaponTT.weaponmodel);
        TrySpawnWorldModel(player).SetModelSimple(weaponTT.weaponmodel);
        weaponEnt.DisableDraw();
    }
    else
    {
        SetPropInt(TrySpawnViewModel(player), "m_nModelIndex", GetPropInt(weaponEnt, "m_iWorldModelIndex"))
    }
}

::GetWorldModel <- function(player)
{
    return worldModels[player.entindex()];
}

::TrySpawnWorldModel <- function(player)
{
    local playerIndex = player.entindex();
    /*local oldWorldModel = worldModels[playerIndex];
    if (oldWorldModel && oldWorldModel.IsValid())
        oldWorldModel.Kill();*/
    local worldModel = SpawnEntityFromTable("tf_wearable", { });
    SetPropBool(worldModel, "m_bForcePurgeFixedupStrings", true);
    SetPropBool(worldModel, "m_bValidatedAttachedEntity", true);
    SetPropBool(worldModel, "m_AttributeManager.m_Item.m_bInitialized", true);
	//worldModel.SetModelSimple(model);
    EntFireByHandle(worldModel, "SetParent", "!activator", 0, player, player);
	SetPropEntity(worldModel, "m_hOwnerEntity", player);
    worldModel.SetOwner(player);

    worldModels[playerIndex] = worldModel;

	return worldModel;
}

::TrySpawnHandsModel <- function(player)
{
    local playerIndex = player.entindex();
    local oldHands = handsModels[playerIndex];
    if (oldHands && oldHands.IsValid())
        oldHands.Kill();

    local handsModel = SpawnEntityFromTable("tf_wearable_vm", {
        modelindex = PrecacheModel("models/weapons/c_models/c_merc_arms.mdl")
    })
    SetPropBool(handsModel, "m_bForcePurgeFixedupStrings", true);
    player.EquipWearableViewModel(handsModel);
    handsModels[playerIndex] = handsModel;

	return handsModel;
}

::TrySpawnViewModel <- function(player)
{
    local playerIndex = player.entindex();

    local viewModel = SpawnEntityFromTable("tf_wearable_vm", { })
    SetPropBool(viewModel, "m_bForcePurgeFixedupStrings", true);
    player.EquipWearableViewModel(viewModel);
    viewModels[playerIndex] = viewModel;

	return viewModel;
}